#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <Math.h>
#include "BQ.h"
//-------------------------------------------------------------------------------------------------------------//
#define __Toolfuncs_here____
//-------------------------------------------------------------------------------------------------------------//
double  ABS_DBL(double val)
{
	double r;
	if (val>0)
	{
		r=val;
	}
	else
	{
		r=val;
		r=r*(-1);
	}
	return(r);
}
int64_t DBL_2_I64(double val)
{
	val=val*2147483647.0;
	val=val*2147483647.0;
	return((int64_t) val);
}
double I64_2_DBL(int64_t val)
{
	double d;
	d=(double)val;
	d=d/2147483647.0;
	d=d/2147483647.0;
	return(d);
}
int32_t DBL_2_I32(double val)
{
	val=val*2147483647.0;
	return((int32_t) val);
}
double I32_2_DBL(int32_t val)
{
	double d;
	d=(double)val;
	d=d/2147483647.0;
	return(d);
}

double DBL_2_32LSBs(double val)
{
	val=val*2147483647.0;
	return(val);
}
float I32_2_FLT(int32_t val)
{
	double d;
	d=(double)val;
	d=d/2147483647.0;
	return((float)d);
}
uint32_t NumOfBits(int64_t NUM)
{
	uint64_t h;
	h=abs(NUM);
	if (h<1)	return(0);
	if (h<2)	return(1);
	if (h<4)	return(2);
	if (h<8)	return(3);
	if (h<16)	return(4);
	if (h<32)	return(5);
	if (h<64)	return(6);
	if (h<128)	return(7);
	if (h<256)	return(8);
	if (h<512)	return(9);
	if (h<1024)	return(10);
	if (h<2048)	return(11);
	if (h<4096)	return(12);
	if (h<8192)	return(13);
	if (h<16384)	return(14);
	if (h<35536)	return(15);
	if (h<65536)	return(16);
	if (h<131072)	return(17);
	if (h<262144)	return(18);
	if (h<(262144*2))	return(19);
	if (h<(262144*4))	return(20);
	if (h<(262144*8))	return(21);
	if (h<(262144*16))	return(22);
	if (h<(262144*32))	return(23);
	if (h<(262144*64))	return(24);
	return(99);
}

double Shift_2_DBLval(uint32_t shift)
{
	uint32_t cnt;
	double val;
	val=1;
	if (shift>0)
	{
		for (cnt=0;cnt<shift;cnt++)	val=val*2;
	}
	return(val);

}
//-------------------------------------------------------------------------------------------------------------//
int32_t singen_24Bit_I32(double f0,double gain, double fs, int32_t timestep)
{
	double sig;
	double ts;

	int32_t s24B;
	ts=(double)timestep;
	sig=sin(2*3.1415926*ts*(f0/fs));
	sig=sig*gain;
	s24B=DBL_2_I32(sig);
	s24B=s24B >> 8;		// make 24 Bit
	s24B=s24B << 8;		// make 32 Bit
	return(s24B);
}
int64_t singen_24Bit_I64(double f0,double gain, double fs, int32_t timestep)
{
	double sig;
	double ts;

	int32_t s24B;
	int64_t s64B;

	ts=(double)timestep;
	sig=sin(2*3.1415926*ts*(f0/fs));
	sig=sig*gain;
	s24B=DBL_2_I32(sig);
	s24B=s24B >> 8;		// make 24 Bit
	s24B=s24B << 8;		// make 32 Bit
	s64B=(int64_t) s24B;
	s64B=s64B << 31;
	return(s64B);
}
double singen_24Bit_DBL(double f0,double gain, double fs, int32_t timestep)
{
	double sig;
	double ts;

	int32_t s24B;

	ts=(double)timestep;
	sig=sin(2*3.1415926*ts*(f0/fs));
	sig=sig*gain;
	s24B=DBL_2_I32(sig);
	s24B=s24B >> 8;		// make 24 Bit
	s24B=s24B << 8;		// make 32 Bit
	return(I32_2_DBL(s24B));
}

double singen_multi_DBL(double fs, int32_t timestep,
						double f1,double phase1, double gain1,
						double f2,double phase2, double gain2,
						double f3,double phase3, double gain3)
    {
    	double yout1=0;
    	double yout2=0;
    	double yout3=0;
    	double ts;
    	double ph;
    	// timestep=0  --> 0
    	// timestep=f0 --> 360
    	// timestep=fs --> n*f0
    	ts=(double)timestep;

    	ph=phase1;
    	ph=ph/360;
    	ph=ph*2*3.1415926;
    	yout1=sin((2*3.1415926*ts/(fs/f1))+(phase1));
    	yout1=yout1*gain1;

    	ph=phase2;
    	ph=ph/360;
    	ph=ph*2*3.1415926;
    	yout2=sin((2*3.1415926*ts/(fs/f2))+(phase2));
    	yout2=yout2*gain2;


    	ph=phase3;
    	ph=ph/360;
    	ph=ph*2*3.1415926;
    	yout3=sin((2*3.1415926*ts/(fs/f3))+(phase3));
    	yout3=yout3*gain3;




    	return(yout1+yout2+yout3);
    }




//-------------------------------------------------------------------------------------------------------------//
#define __BQFilters_here____
//-------------------------------------------------------------------------------------------------------------//
// Double Precision 32x32 in 64
// coefficients as /2 !
void DPQB(int64_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int64_t *D1,int64_t *D2,int64_t *Dy1,int64_t *Dy2,
		  int64_t *Res64	)
{
				int64_t data64;
				int64_t AKKU;
				int64_t AKKU2;



				data64=datain;
				data64=data64 >> datapreshift;
				datain=data64;

				AKKU=(data64>>32)*b0;						// <-- DPMUL(3)...
				AKKU2=(data64 & 0xFFFFFFFF)*(b0); 		 	// ... -->

				data64=*D1;
				AKKU+=(data64>>32)*b1;						// <-- DPMUL(3)...
				AKKU2+=(data64 & 0xFFFFFFFF)*(b1); 		 	// ... -->

				data64=*D2;
				AKKU+=(data64>>32)*b2;						// <-- DPMUL(3)...
				AKKU2+=(data64 & 0xFFFFFFFF)*(b2); 		 	// ... -->


				data64=*Dy1;
				AKKU+=(data64>>32)*a1;						// <-- DPMUL(3)...
				AKKU2+=(data64 & 0xFFFFFFFF)*(a1); 		 	// ... -->


				data64=*Dy2;
				AKKU+=(data64>>32)*a2;						// <-- DPMUL(3)...
				AKKU2+=(data64 & 0xFFFFFFFF)*(a2); 		 	// ... -->

				AKKU=(AKKU<<1);				// compensate "lost" multiplication bit
				AKKU2=AKKU2 >> 31;
				AKKU+=AKKU2;
				AKKU=(AKKU<<1); 			// compensate "coeff/2"

				*D2=*D1;
				*D1=datain;
				*Dy2=*Dy1;
				*Dy1=AKKU;

				AKKU=(AKKU<<datapreshift); 	// compensate "data preshift"


				*Res64=AKKU;



}
//-------------------------------------------------------------------------------------------------------------//
// Double Precision 64x32 in 64 for a1,a2
// Single Precision 32x32 in 64 for b0,b1,b2
// Don't use noise shape here (noise shape is done by double precision :-) !
//-------------------------------------------------------------------------------------------------------------//
void DPSPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,
		  int32_t *Dy1H,uint32_t *Dy1L,
		  int32_t *Dy2H,uint32_t *Dy2L,
		  int64_t *Res64)
{

				uint32_t buffer[128];		// use uint32 buffer, int/uint will be corrected by datatype in function
				uint32_t *bptr;
				bptr=&buffer[0];			// 32 = 1 REG
				*(bptr++)=b0; 	// 0
				*(bptr++)=b2; 	// 1
				*(bptr++)=*D2;  // 2
				*(bptr++)=b1;   // 3
				*(bptr++)=*D1;  // 4

				*(bptr++)=*Dy2H; // 5
				*(bptr++)=*Dy2L; // 6
				*(bptr++)=a2;	 // 7
				*(bptr++)=*Dy1H; // 8
				*(bptr++)=*Dy1L; // 9
				*(bptr++)=a1;    // 10


				int64_t AKKU;				// 64 = 2 REG
				int64_t AKKU2;				// 64 = 2 REG

				int32_t     c1;				// 32 = 1 REG
				int32_t		D1H;			// 32 = 1 REG
				uint32_t	D1L;			// 32 = 1 REG


				bptr=&buffer[0];			// set pointer to buffer
											// -- prev. BQ output sample is then in newpos[0]-6 --> Dy2H or HI(AKK


				c1=*(bptr);		//b0

															// IN(32)*b0
				AKKU=(int64_t)(datain)*c1;					// <-- SPMUL()...

				AKKU=AKKU >>  datapreshift;

				c1=*(bptr+1);	//b2
				D1H=*(bptr+2);	//D2						// D2*b2
				AKKU+=(int64_t)(D1H)*c1;					// <-- SPMUL(3)...

				c1=*(bptr+3);	//b1
				D1H=*(bptr+4);	//D1						// D1*b1
				AKKU+=(int64_t)(D1H)*c1;					// <-- SPMUL(3)...

				*(bptr+2)=D1H;								// D2=D1
				*(bptr+4)=(datain>>  datapreshift);			// D1=IN

				D1H=*(bptr+5);
				D1L=*(bptr+6);
				c1=*(bptr+7);	//a2
				AKKU2=0;								// D2(64)*a2
				AKKU+=(int64_t)(D1H)*c1;				// <-- DPMUL()...
				AKKU2+=(int64_t)(D1L)*(c1); 			// ... -->

				D1H=*(bptr+8);
				D1L=*(bptr+9);
				c1=*(bptr+10);	//a1
														// D1(64)*a1
				AKKU+=(int64_t)(D1H)*c1;				// <-- DPMUL()...
				AKKU2+=(int64_t)(D1L)*(c1); 			// ... -->


				// signed*unsigned modes .... see below for precision
				//(a)AKKU2=AKKU2 >> 32;			// (a) prepare AKKU2 (only upper bits)
				AKKU2=AKKU2 >> 31;				// (b) prepare AKKU2 (only upper bits) and sig*sig compensation
				//(c)AKKU2=AKKU2 >> 29;			// (c) prepare AKKU2 (only upper bits) and sig*sig compensation

				AKKU+=AKKU2;				// add AKKUs
				AKKU=(AKKU<<2); 			// compensate "lost" multiplication bit & "coeff/2"

				*(bptr+5)=D1H;				// D2 new = D1 old
				*(bptr+6)=D1L;				// D2 new = D1 old


				*(bptr+8)=(int32_t)(AKKU >> 32);				// Dy1 new = AKKU

				//												// 1/32 Bit = 4.6E-10
				//	*(bptr+9)=(uint32_t)(AKKU & 0xFFFFFFFF);	// (a) Dy1 new = AKKU
				*(bptr+9)=((uint32_t)(AKKU & 0xFFFFFFFF)>>1);	// (b) Dy1 new = (AKKU_LO)/2
																// --> Error to DP64: -0.00000000000038 = 3.8 E-13
																//     Error ~ 1/1000 LSB of 32Bit
				//*(bptr+9)=((uint32_t)(AKKU & 0xFFFFFFFF)>>3);	// (c) Dy1 new = (AKKU_LO)/8 (test purpose)
																// --> Error to DP64: -0.00000000000121


				AKKU=(AKKU<<datapreshift); 						// compensate "data preshift"



				*D2=*(bptr+2); // 2
				*D1=*(bptr+4); // 4

				*Dy2H=*(bptr+5); // 5
				*Dy2L=*(bptr+6); // 6
				*Dy1H=*(bptr+8); // 8
				*Dy1L=*(bptr+9); // 9


				*Res64=AKKU;

				//TEST//
				//*Res64=0;

				// Cortex M3
				// ?? datamove= 	  20 cycles
				// ?? MUL SP  = 5x7 = 35 cycles
				// ?? MUL DP  = 2x10= 20 cycles
				// ?? SHIFT   = 7x1   7  cycles
				// SUM:				  82 cycles
				// --> realistic: ~ 100 cycles

				// Cortex M4
				// ?? datamove= 	  20 cycles
				// ?? MUL SP  = 5x2 = 10 cycles
				// ?? MUL DP  = 2x4=   8 cycles
				// ?? SHIFT   = 7x1    7 cycles
				// SUM:				  45 cycles
				// --> realistic: ~ 60   cycles

}
//-------------------------------------------------------------------------------------------------------------//
// Test stuff below
//-------------------------------------------------------------------------------------------------------------//
// Single Precision 32x32
// coefficients as /2 !
void SPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,int32_t *Dy1,int32_t *Dy2,uint32_t *Nshape,uint32_t *Nshape2,
		  int32_t *Res32, uint32_t bool_Nshape	)
{
				int32_t data32;
				int64_t AKKU;
				uint32_t dataLO;



				data32=datain;
				data32=data32 >> datapreshift;
				datain=data32;

				if (bool_Nshape==1)
				{
					dataLO=*Nshape;
					dataLO=dataLO>> (datapreshift-1);
					AKKU=(int64_t)dataLO;
					AKKU+=((int64_t)data32)*b0;				// <-- DPMUL(3)... (sig x sig)
				}

				if (bool_Nshape==0)
				{
					AKKU=((int64_t)data32)*b0;				// <-- DPMUL(3)... (sig x sig)
				}
				data32=*D1;
				AKKU+=((int64_t)data32)*b1;				// <-- DPMUL(3)... (sig x sig)

				data32=*D2;
				AKKU+=((int64_t)data32)*b2;				// <-- DPMUL(3)... (sig x sig)

				data32=*Dy1;
				AKKU+=((int64_t)data32)*a1;				// <-- DPMUL(3)... (sig x sig)

				data32=*Dy2;
				AKKU+=((int64_t)data32)*a2;				// <-- DPMUL(3)... (sig x sig)

				AKKU=(AKKU<<1);				// compensate "lost" multiplication bit
				AKKU=(AKKU<<1); 			// compensate "coeff/2"

				*D2=*D1;
				*D1=datain;
				*Dy2=*Dy1;
				*Dy1=(int32_t)(AKKU>>32);
				*Nshape2=*Nshape;
				*Nshape=AKKU & 0xFFFFFFFF;
				AKKU=(AKKU<<datapreshift); 	// compensate "data preshift"


				*Res32=(int32_t)(AKKU>>32);
}
//-------------------------------------------------------------------------------------------------------------//
// DOUBLE FLOAT reference
// coefficients as /2 !
void DBLBQ(double datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   double *D1,double *D2,double *Dy1,double *Dy2,
		   double *Resdbl	)
{
				double dAKKU;

				datain=datain/Shift_2_DBLval(datapreshift);
				dAKKU=(datain)*I32_2_DBL(b0);
				dAKKU+=(*D1)*I32_2_DBL(b1);
				dAKKU+=(*D2)*I32_2_DBL(b2);
				dAKKU+=(*Dy1)*I32_2_DBL(a1);
				dAKKU+=(*Dy2)*I32_2_DBL(a2);
				dAKKU=dAKKU*2.0;	// coeff comp.


				*D2=*D1;
				*D1=datain;
				*Dy2=*Dy1;
				*Dy1=dAKKU;
				dAKKU=dAKKU*Shift_2_DBLval(datapreshift);
				*Resdbl=dAKKU;
}
//-------------------------------------------------------------------------------------------------------------//
// SINGLE FLOAT, results ~ 32Bit single precision !
// coefficients as /2 !
void FLTBQ(float datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   float *D1,float *D2,float *Dy1,float *Dy2,
		   float *Resdbl	)
{
				float dAKKU;

				datain=datain/(float)Shift_2_DBLval(datapreshift);
				dAKKU=(datain)*I32_2_FLT(b0);
				dAKKU+=(*D1)*I32_2_FLT(b1);
				dAKKU+=(*D2)*I32_2_FLT(b2);
				dAKKU+=(*Dy1)*I32_2_FLT(a1);
				dAKKU+=(*Dy2)*I32_2_FLT(a2);
				dAKKU=dAKKU*2.0;	// coeff comp.


				*D2=*D1;
				*D1=datain;
				*Dy2=*Dy1;
				*Dy1=dAKKU;
				dAKKU=dAKKU*(float)Shift_2_DBLval(datapreshift);
				*Resdbl=dAKKU;
}
//-------------------------------------------------------------------------------------------------------------//
// DOUBLE FLOAT reference
// coefficients as /2 !
void DBLBQ_PEAK(double datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   double *D1,double *D2,double *Dy1,double *Dy2,
		   double *Resdbl, double *PeakAkku, double *PeakOut	)
{
				double dAKKU;
				double PEAKi=0;
				double PEAKo=0;

				datain=datain/Shift_2_DBLval(datapreshift);
				dAKKU=(datain)*I32_2_DBL(b0);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);

				dAKKU+=(*D1)*I32_2_DBL(b1);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);

				dAKKU+=(*D2)*I32_2_DBL(b2);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);

				dAKKU+=(*Dy1)*I32_2_DBL(a1);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);

				dAKKU+=(*Dy2)*I32_2_DBL(a2);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);

				dAKKU=dAKKU*2.0;	// coeff comp.
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);


				*D2=*D1;
				*D1=datain;
				*Dy2=*Dy1;
				*Dy1=dAKKU;
				dAKKU=dAKKU*Shift_2_DBLval(datapreshift);
				if (ABS_DBL(dAKKU)>PEAKi)PEAKi=ABS_DBL(dAKKU);
				if (ABS_DBL(dAKKU)>PEAKo)PEAKo=ABS_DBL(dAKKU);

				*PeakAkku=PEAKi;
				*PeakOut=PEAKo;
				*Resdbl=dAKKU;
}
