/*
 * BQ_TEST.c
 *
 *  Created on: 03.11.2015
 *      Author: ACAV
 */
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "BQ.h"

//********************************************************************************************//
// Declaration



//********************************************************************************************//
// Functions

void TEST_BitSizeMul(double sin_f, double sin_gain,double coeff_1,double coeff_2,double coeff_3,double coeff_4,double coeff_5)
{
	// coefficients must be coeff/2 !
	uint32_t datashift;
	uint32_t loop;

	int64_t sig64;
	int64_t res64;
	int64_t D1_64;
	int64_t D2_64;
	int64_t Dy1_64;
	int64_t Dy2_64;
	double  res64_2_dbl;


	int64_t  res64SP;
	int32_t  D1_64SP;
	int32_t  D2_64SP;
	int32_t  Dy1H_64SP;
	uint32_t Dy1L_64SP;
	int32_t  Dy2H_64SP;
	uint32_t Dy2L_64SP;

	double  res64SP_2_dbl;


	int32_t sig32;
	int32_t res32;
	int32_t D1_32;
	int32_t D2_32;
	int32_t Dy1_32;
	int32_t Dy2_32;
	uint32_t NS_32_1;
	uint32_t NS_32_2;
	double  res32_2_dbl;

	int32_t res32_ns;
	int32_t D1_32_ns;
	int32_t D2_32_ns;
	int32_t Dy1_32_ns;
	int32_t Dy2_32_ns;
	uint32_t NS_32_ns1=0;
	uint32_t NS_32_ns2=0;
	double  res32_ns_2_dbl;



	double sig_d;

	double D1_d;
	double D2_d;
	double Dy1_d;
	double Dy2_d;
	double res_dbl;

	float res_f;
	float D1_f;
	float D2_f;
	float Dy1_f;
	float Dy2_f;
	double resf_dbl;




	double delta_d32;
	double delta_d32_ns;

	double delta_d64;
	double delta_d64SP;
	double delta_f;


	double maxd32;
	double maxd32_ns;



	double maxdf;
	double maxd64;
	double maxd64SP;






	datashift=3;


	D1_32=0;D2_32=0;Dy1_32=0;Dy2_32=0;
	D1_32_ns=0;D2_32_ns=0;Dy1_32_ns=0;Dy2_32_ns=0;

	D1_64=0;D2_64=0;Dy1_64=0;Dy2_64=0;
	D1_64SP=0;D2_64SP=0;
	Dy1H_64SP=0;Dy1L_64SP=0;
	Dy2H_64SP=0;Dy2L_64SP=0;

	D1_d=0;D2_d=0;Dy1_d=0;Dy2_d=0;
	D1_f=0;D2_f=0;Dy1_f=0;Dy2_f=0;



	maxd32=0.0;
	maxd32_ns=0.0;
	maxd64=0.0;
	maxdf=0.0;
	maxd64SP=0.0;

	for (loop=0;loop<96000;loop++)
	{
		sig64=singen_24Bit_I64(sin_f,sin_gain,96000.0,loop);
		sig32=singen_24Bit_I32(sin_f,sin_gain,96000.0,loop);
		sig_d=singen_24Bit_DBL(sin_f,sin_gain,96000.0,loop);

		 DBLBQ(sig_d,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
							 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
							 &D1_d,&D2_d,&Dy1_d,&Dy2_d,&res_dbl);

		 FLTBQ((float)sig_d,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
							 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
							 &D1_f,&D2_f,&Dy1_f,&Dy2_f,&res_f);

		 resf_dbl=(double)res_f;


		 DPQB(sig64,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
												 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
												 &D1_64,&D2_64,&Dy1_64,&Dy2_64,&res64);


		res64_2_dbl=I64_2_DBL(res64);

		// 32/64Bit mixed !
		DPSPQB((int32_t)(sig64>>32),datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
								 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
								 &D1_64SP,&D2_64SP,
								 &Dy1H_64SP,&Dy1L_64SP,
								 &Dy2H_64SP,&Dy2L_64SP,&res64SP);

		res64SP_2_dbl=I64_2_DBL(res64SP);

		// 32x32 SP without error Feedback
		SPQB(sig32,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
							 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
							 &D1_32,&D2_32,&Dy1_32,&Dy2_32,
							 &NS_32_1,&NS_32_2,&res32,+0);



		// 32x32 SP with single error Feedback
		SPQB(sig32,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
							 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
							 &D1_32_ns,&D2_32_ns,&Dy1_32_ns,&Dy2_32_ns,
							 &NS_32_ns1,&NS_32_ns2,&res32_ns,+1);


		res32_2_dbl=I32_2_DBL(res32);
		res32_ns_2_dbl=I32_2_DBL(res32_ns);


		delta_d32=res_dbl-res32_2_dbl;
		delta_d32_ns=res_dbl-res32_ns_2_dbl;
		delta_d64=res_dbl-res64_2_dbl;
		delta_d64SP=res_dbl-res64SP_2_dbl;
		delta_f=res_dbl-resf_dbl;



		if (ABS_DBL(delta_d32)>maxd32)maxd32=ABS_DBL(delta_d32);
		if (ABS_DBL(delta_d32_ns)>maxd32_ns)maxd32_ns=ABS_DBL(delta_d32_ns);
		if (ABS_DBL(delta_d64)>maxd64)maxd64=ABS_DBL(delta_d64);
		if (ABS_DBL(delta_d64SP)>maxd64SP)maxd64SP=ABS_DBL(delta_d64SP);
		if (ABS_DBL(delta_f)>maxdf)maxdf=ABS_DBL(delta_f);



		// put out intermediate data
		//if ((loop % 950) == 0)	printf("l32:%8.1f   |l32ns:%8.1f   |l64:%8.1f    \r",DBL_2_32LSBs(delta_d32),DBL_2_32LSBs(delta_d32_ns),DBL_2_32LSBs(delta_d64));
		//if ((loop % 950) == 0)	printf("l64:%8.1f    \r",DBL_2_32LSBs(delta_d64));
		//if ((loop <96))		printf("DBL:%12.8f     64:%12.8f    \r",res_dbl,res64_2_dbl);


	}


#ifdef OUTPUTMODE_TABLE

	//printf(";;;;;;;;;;;;;");
	printf("%+12.10f;%+12.3f;",maxd32,DBL_2_32LSBs(maxd32));
	printf("%+12.10f;%+12.3f;",maxd32_ns,DBL_2_32LSBs(maxd32_ns));
	printf("%+12.10f;%+12.3f;",maxd64SP,DBL_2_32LSBs(maxd64SP));
	printf("%+12.10f;%+12.3f;",maxd64,DBL_2_32LSBs(maxd64));
	printf("%+12.10f;%+12.3f;\n",maxdf,DBL_2_32LSBs(maxdf));




#endif
#ifndef OUTPUTMODE_TABLE

	printf("max delta   32BIT  :%+12.10f   32BIT-NS1:%+12.10f    64BIT-SPDP:%+12.10f  64BIT:%+12.10f   float:%+12.10f\r",maxd32,maxd32_ns,maxd64SP,maxd64,maxdf);
	printf("max 32LSB   32BIT  :%+12.3f    32BIT-NS1:%+12.3f     64BIT-SPDP:%+12.3f   64BIT:%+12.3f    float:%+12.3f\r",DBL_2_32LSBs(maxd32),DBL_2_32LSBs(maxd32_ns),DBL_2_32LSBs(maxd64SP),  DBL_2_32LSBs(maxd64),DBL_2_32LSBs(maxdf));
	printf("BITS loss   32BIT  :%+12d    32BIT-NS1:%+12d     64BIT-SPDP:%+12d   64BIT:%+12d    float:%+12d\r",	NumOfBits((uint32_t)DBL_2_32LSBs(maxd32)),
																							NumOfBits((uint32_t)DBL_2_32LSBs(maxd32_ns)),
																							NumOfBits((uint32_t)DBL_2_32LSBs(maxd64SP)),
																							NumOfBits((uint32_t)DBL_2_32LSBs(maxd64)),
																							NumOfBits((uint32_t)DBL_2_32LSBs(maxdf)) );
	printf("max delta   DP 64BIT to DPSP 64BIT:%+16.14f  \r",maxd64-maxd64SP);
#endif
}



















void TEST_AKKUPEAK(double coeff_1,double coeff_2,double coeff_3,double coeff_4,double coeff_5,
				  double f1,double phase1, double gain1,
				  double f2,double phase2, double gain2,
				  double f3,double phase3, double gain3)



{
	// coefficients must be coeff/2 !
	uint32_t datashift;
	uint32_t loop;



	double D1_d;
	double D2_d;
	double Dy1_d;
	double Dy2_d;
	double res_dbl;

	double PEAKvi=0;
	double PEAKvo=0;
	double PEAKi=0;
	double PEAKo=0;
	double sig_d;

	datashift=3;

	D1_d=0;D2_d=0;Dy1_d=0;Dy2_d=0;

	for (loop=0;loop<96000;loop++)
	{
		sig_d=singen_multi_DBL(96000,loop,f1,phase1,gain1,f2,phase2,gain2,f3,phase3,gain3);

		DBLBQ_PEAK(sig_d,datashift,DBL_2_I32((-1.0)*coeff_1),DBL_2_I32((-1.0)*coeff_2),
							 DBL_2_I32(coeff_3/1.0),DBL_2_I32(coeff_4/1.0),DBL_2_I32(coeff_5/1.0),
							 &D1_d,&D2_d,&Dy1_d,&Dy2_d,&res_dbl,&PEAKvi,&PEAKvo);

		if (ABS_DBL(PEAKvi)>PEAKi)PEAKi=ABS_DBL(PEAKvi);
		if (ABS_DBL(PEAKvo)>PEAKo)PEAKo=ABS_DBL(PEAKvo);



	}
	printf("PEAK AKKU: %+10.5f  PEAK OUT: %+10.5f  \r",PEAKi,PEAKo);

}

