/*
 ============================================================================
 Name        : BiquadTest.c
 Author      : ACAV
 Version     :
 Copyright   : (C) ACAV, 2015
 	 	 	   Do NOT use for business purposes !
 	 	 	   ONLY for private use !
 Description :
 ============================================================================
 */

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "BQ.h"


//------------------------------------------------------------------------------//
//------------------------------------------------------------------------------//
//------------------------------------------------------------------------------//



int main(void) {

	// For output mode definition see "BQ.h"
#ifdef OUTPUTMODE_TABLE
	printf("Table output\r");
#endif
#ifndef OUTPUTMODE_TABLE
	printf("Screen output\r");
#endif


	// Test for filter output in reference to Double-Precision-float
	// Varios (low frequency) filter and sine test signals



	double coeff_1;	// a1
	double coeff_2; // a2
	double coeff_3; // b0
	double coeff_4; // b1
	double coeff_5; // b2

	// comment out if you don't want to see precision
	// use if you want to see AKKU peak

	//goto MARK_ONLYPEAK;
#ifdef OUTPUTMODE_TABLE
	printf("Filter;Filter;Filter;Filter;Gen 1;Gen 1;Gen 1;Gen 2;Gen 2;Gen 2;Gen 3;Gen 3;Gen 3;");
	printf("INT32;INT32;         INT32NS;INT32NS;    INT64SPDP;INT64SPDP;     INT64DP;INT64DP;     float;float    \n");

	printf("Type;f0;q0;g0;f1;Phase1;Gain1;f2;Phase2;Gain2;f3;Phase3;Gain3;");
	printf("delta;32LSB;         delta;32LSB;         delta;32LSB;            delta;32LSB;          delta;32LSB\n");
#endif


	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
	//PEAK     f= 1000,0  q=6,00  g=12,00 dB   coeff scaled by /2
	//a1:-0,995140596074 	a2:0,497275840201  b0:0,504060457850  b1:-0,995140596074  b2:0,493215382351
	coeff_1=-0.995140596074; 	coeff_2=0.497275840201;  coeff_3=0.504060457850;  coeff_4=-0.995140596074;  coeff_5=0.493215382351;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=1k, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	double f0;
	double g0;
	double f1;
	double g1;
	double f2;
	double g2;

	f1=0.0;g1=0.0;f2=0.0;g2=0.0;



	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif

	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);

#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=500.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=2000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=5000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;1000;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif


	//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
	//PEAK     f=   35,0  q=6,00  g=12,00 dB   coeff scaled by /2
	//a1:-0,999901711402 	         a2:0,499904334905         b0:0,500142592253        b1:-0,999901711402        b2:0,499761742652
	coeff_1=-0.999901711402 ; 	coeff_2=0.499904334905 ;  coeff_3=0.500142592253;  coeff_4=-0.999901711402;  coeff_5=0.499761742652;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=35, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=500.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=2000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=5000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;

#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;+12;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
#ifndef OUTPUTMODE_TABLE
//	------------------------------------------------
//	PEAK     f=   35.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1:-0.999616636225 	a2:0.499619258980  b0:0.499857448400  b1:-0.999616636225  b2:0.499761810580
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=35, q=6; g=-12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	coeff_1=-0.999616636225; 	coeff_2=0.499619258980;  coeff_3=0.499857448400;  coeff_4=-0.999616636225;  coeff_5=0.499761810580;
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=5000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;35;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   50.0  q=6.00  g=12.00 dB   coeff scaled by /2
//	a1=-0.999857987440 	a2=0.499863341307  b0=0.500203694682  b1=-0.999857987440  b2=0.499659646624
	coeff_1=-0.999857987440 ;	coeff_2=0.499863341307 ; coeff_3=0.500203694682;  coeff_4=-0.999857987440;  coeff_5=0.499659646624 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=50, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=50.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=75.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif

//	------------------------------------------------
//	PEAK     f=   50.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1=-0.999450821805 	a2=0.499456173491  b0=0.499796388267  b1=-0.999450821805  b2=0.499659785224
	coeff_1=-0.999450821805 	;coeff_2=0.499456173491  ;coeff_3=0.499796388267 ; coeff_4=-0.999450821805; coeff_5=0.499659785224;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=50, q=6; g=-12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=50.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=75.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;50;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   60.0  q=6.00  g=12.00 dB   coeff scaled by /2
//	a1=-0.999828304825 	a2=0.499836014179  b0=0.500244426746  b1=-0.999828304825  b2=0.499591587433
	coeff_1=-0.999828304825; 	coeff_2=0.499836014179;  coeff_3=0.500244426746;  coeff_4=-0.999828304825;  coeff_5=0.499591587433;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=60, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=60.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//
//	------------------------------------------------
//	PEAK     f=   60.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1=-0.999339774086 	a2=0.499347479673  b0=0.499755692684  b1=-0.999339774086  b2=0.499591786989
	coeff_1=-0.999339774086; 	coeff_2=0.499347479673 ; coeff_3=0.499755692684 ; coeff_4=-0.999339774086;  coeff_5=0.499591786989 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=60, q=6; g=-12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");

#endif
	f0=60.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;60;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   70.0  q=6.00  g=12.00 dB   coeff scaled by /2
//	a1=-0.999798195619 	a2=0.499808688615  b0=0.500285156479  b1=-0.999798195619  b2=0.499523532136
	coeff_1=-0.999798195619 ;	coeff_2=0.499808688615;  coeff_3=0.500285156479 ; coeff_4=-0.999798195619 ; coeff_5=0.499523532136 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=70, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=70.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3


	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   70.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1=-0.999228322759 	a2=0.499238809774  b0=0.499715006057  b1=-0.999228322759  b2=0.499523803717
	coeff_1=-0.999228322759 ;	coeff_2=0.499238809774 ; coeff_3=0.499715006057 ; coeff_4=-0.999228322759 ; coeff_5=0.499523803717 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=70, q=6; g=-12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=70.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;70;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   80.0  q=6.00  g=12.00 dB   coeff scaled by /2
//	a1=-0.999767659871 	a2=0.499781364626  b0=0.500325883863  b1=-0.999767659871  b2=0.499455480763
	coeff_1=-0.999767659871 ;	coeff_2=0.499781364626 ; coeff_3=0.500325883863 ; coeff_4=-0.999767659871  ;coeff_5=0.499455480763 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=80, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=80.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
//	------------------------------------------------
//	PEAK     f=   80.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1=-0.999116468002 	a2=0.499130163831  b0=0.499674328399  b1=-0.999116468002  b2=0.499455835432
	coeff_1=-0.999116468002; 	coeff_2=0.499130163831;  coeff_3=0.499674328399;  coeff_4=-0.999116468002;  coeff_5=0.499455835432 ;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=80, q=6; g=*12dB \r");
	printf("-----------------------------------------------------\r");
#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=80.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE

	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE


	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;80;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif


//	------------------------------------------------
//	PEAK     f=  100.0  q=6.00  g=12.00 dB   coeff scaled by /2
//	a1=-0.999705308939 	a2=0.499726721422  b0=0.500407331518  b1=-0.999705308939  b2=0.499319389904
	coeff_1=-0.999705308939; 	coeff_2=0.499726721422;  coeff_3=0.500407331518;  coeff_4=-0.999705308939;  coeff_5=0.499319389904;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=100, q=6; g=+12dB \r");
	printf("-----------------------------------------------------\r");

#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=5000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
	f0=12000.0;g0=0.1;
#endif
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;+12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif

	//	------------------------------------------------
//	PEAK     f=  100.0  q=6.00  g=-12.00 dB   coeff scaled by /2
//	a1=-0.998891548917 	a2=0.498912943970  b0=0.499593000050  b1=-0.998891548917  b2=0.499319943920
	coeff_1=-0.998891548917; 	coeff_2=0.498912943970;  coeff_3=0.499593000050;  coeff_4=-0.998891548917; coeff_5=0.499319943920;
#ifndef OUTPUTMODE_TABLE
	printf("-----------------------------------------------------\r");
	printf("-- PEAK filter, f0=100, q=6; g=-12dB \r");
	printf("-----------------------------------------------------\r");

#endif
	f0=10.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=35.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=100.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif

	f0=200.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=1000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=5000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif
	f0=12000.0;g0=0.1;
#ifdef OUTPUTMODE_TABLE
	printf("PEAK;100;6;-12.0;");
	printf("%8.1f;0.0;%7.5f;",f0,g0);		// f1,phase1,gain1
	printf("%8.1f;0.0;%7.5f;",f1,g1);		// f2,phase2,gain2
	printf("%8.1f;0.0;%7.5f;",f2,g2);		// f3,phase3,gain3

	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
#endif
#ifndef OUTPUTMODE_TABLE
	printf("-- ftest: %8.0f   g0:%8.5f \r",f0,g0);
	TEST_BitSizeMul(f0,g0,coeff_1,coeff_2,coeff_3,coeff_4,coeff_5);
	printf("-----------------------------------------------------\r");
#endif

	return(0);
	MARK_ONLYPEAK:

	f0=0;


	double f3=0;
	double p1=0;
	double p2=0;
	double p3=0;

	double g3=0;


	//	------------------------------------------------
	//	PEAK     f=  100.0  q=6.00  g=12.00 dB   coeff scaled by /2
	//	a1=-0.999705308939 	a2=0.499726721422  b0=0.500407331518  b1=-0.999705308939  b2=0.499319389904
	coeff_1=-0.999705308939; 	coeff_2=0.499726721422;  coeff_3=0.500407331518;  coeff_4=-0.999705308939;  coeff_5=0.499319389904;



	f1=1.0;p1=0;g1=0.25;
	f2=100.0;p2=60.0;g2=0.5;
	f3=500.0;p3=120.0;g3=0.25;


	printf("-- PEAK f1: %8.0f   g1:%8.5f   p1:%8.5f\r",f1,g1,p1);
	printf("-- PEAK f2: %8.0f   g2:%8.5f   p2:%8.5f\r",f2,g2,p2);
	printf("-- PEAK f3: %8.0f   g3:%8.5f   p3:%8.5f\r",f3,g3,p3);
	TEST_AKKUPEAK(coeff_1,coeff_2,coeff_3,coeff_4,coeff_5,
				  f1,p1,g1,f2,p2,g2,f3,p3,g3);

	f1=1.0;p1=0;g1=0.0;
	f2=100.0;p2=60.0;g2=0.5;
	f3=500.0;p3=120.0;g3=0.0;

	printf("-----------------------------------------------------\r");
	printf("-- PEAK f1: %8.0f   g1:%8.5f   p1:%8.5f\r",f1,g1,p1);
	printf("-- PEAK f2: %8.0f   g2:%8.5f   p2:%8.5f\r",f2,g2,p2);
	printf("-- PEAK f3: %8.0f   g3:%8.5f   p3:%8.5f\r",f3,g3,p3);
	TEST_AKKUPEAK(coeff_1,coeff_2,coeff_3,coeff_4,coeff_5,
				  f1,p1,g1,f2,p2,g2,f3,p3,g3);
	printf("-----------------------------------------------------\r");




	f1=1.0;p1=0;g1=0.5;
	f2=100.0;p2=60.0;g2=0.25;
	f3=500.0;p3=120.0;g3=0.25;


	printf("-- PEAK f1: %8.0f   g1:%8.5f   p1:%8.5f\r",f1,g1,p1);
	printf("-- PEAK f2: %8.0f   g2:%8.5f   p2:%8.5f\r",f2,g2,p2);
	printf("-- PEAK f3: %8.0f   g3:%8.5f   p3:%8.5f\r",f3,g3,p3);
	TEST_AKKUPEAK(coeff_1,coeff_2,coeff_3,coeff_4,coeff_5,
				  f1,p1,g1,f2,p2,g2,f3,p3,g3);

	f1=1.0;p1=0;g1=0.9999;
	f2=100.0;p2=60.0;g2=0.0;
	f3=500.0;p3=120.0;g3=0.0;

	printf("-----------------------------------------------------\r");
	printf("-- PEAK f1: %8.0f   g1:%8.5f   p1:%8.5f\r",f1,g1,p1);
	printf("-- PEAK f2: %8.0f   g2:%8.5f   p2:%8.5f\r",f2,g2,p2);
	printf("-- PEAK f3: %8.0f   g3:%8.5f   p3:%8.5f\r",f3,g3,p3);
	TEST_AKKUPEAK(coeff_1,coeff_2,coeff_3,coeff_4,coeff_5,
				  f1,p1,g1,f2,p2,g2,f3,p3,g3);
	printf("-----------------------------------------------------\r");

	f1=1.0;p1=0;g1=0.5;
	f2=100.0;p2=60.0;g2=0.0;
	f3=500.0;p3=120.0;g3=0.0;

	printf("-----------------------------------------------------\r");
	printf("-- PEAK f1: %8.0f   g1:%8.5f   p1:%8.5f\r",f1,g1,p1);
	printf("-- PEAK f2: %8.0f   g2:%8.5f   p2:%8.5f\r",f2,g2,p2);
	printf("-- PEAK f3: %8.0f   g3:%8.5f   p3:%8.5f\r",f3,g3,p3);
	TEST_AKKUPEAK(coeff_1,coeff_2,coeff_3,coeff_4,coeff_5,
				  f1,p1,g1,f2,p2,g2,f3,p3,g3);
	printf("-----------------------------------------------------\r");
	printf("\n END \n");
	return EXIT_SUCCESS;












	printf("\n END \n");
	return EXIT_SUCCESS;
}







